using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ResPatch
{
    public partial class ResPatcher : Form
    {
        static String SecretCode = "d433569fa83327e75ee847cc70e0a724";

        static bool doTestWriting = true;
        
        static string dirSep = Path.DirectorySeparatorChar.ToString();
        static string BIN_DIR, DLL_DIR, CFG_DIR, BIN_FILE, DLL_FILE, CFG_FILE;
        static string bloodlinesPath;
        
        static int[] resolutions = new int[8];
        static int fov, anamorphic;

        static byte[] binFileContents;
        static int binFileResStringStart;
        static byte[] dllFileContents;
        static int dllFileResStringStart;

        static ASCIIEncoding encoding = new ASCIIEncoding();
        static Byte[] binLookFor = encoding.GetBytes(@"CEngine::Frame");
        static Byte[] dllLookFor = encoding.GetBytes(@"default_fov");

        static string[] dialogBox = { "", "", "", "", "", "", "", "", "" };

        static bool configFileExists = true;

        void updateDialog(String toAdd)
        {
            updateDialog(toAdd, true);
        }

        void updateDialog(String toAdd, bool addTime)
        {
            string[] tempBox = new string[dialogBox.Length];
            for (int i = 0; i < dialogBox.Length; i++)
            {
                tempBox[i] = dialogBox[i];
            }
            for (int i = 1; i < dialogBox.Length; i++)
            {
                dialogBox[i - 1] = tempBox[i];
            }
            if (addTime == true)
                dialogBox[dialogBox.Length - 1] = DateTime.Now.ToString("hh:mm:ss") + " " + toAdd;
            else
                dialogBox[dialogBox.Length - 1] = toAdd;
            displayDialogBox();
        }

        void displayDialogBox()
        {
            StringBuilder fullText = new StringBuilder();
            for (int i = 0; i < dialogBox.Length; i++)
            {
                if (!dialogBox[i].Equals(""))
                fullText.AppendLine(dialogBox[i]);
            }
            this.textBox1.Text = "";
            this.textBox1.AppendText(fullText.ToString());
        }

        void updateOldTextBoxes()
        {
            this.Old_X_Res_1.Text = resolutions[0].ToString();
            this.Old_Y_Res_1.Text = resolutions[1].ToString();
            this.Old_X_Res_2.Text = resolutions[2].ToString();
            this.Old_Y_Res_2.Text = resolutions[3].ToString();
            this.Old_X_Res_3.Text = resolutions[4].ToString();
            this.Old_Y_Res_3.Text = resolutions[5].ToString();
            this.Old_X_Res_4.Text = resolutions[6].ToString();
            this.Old_Y_Res_4.Text = resolutions[7].ToString();
        }

        void updateNewTextBoxes()
        {
            this.X_Res_1.Text = resolutions[0].ToString();
            this.Y_Res_1.Text = resolutions[1].ToString();
            this.X_Res_2.Text = resolutions[2].ToString();
            this.Y_Res_2.Text = resolutions[3].ToString();
            this.X_Res_3.Text = resolutions[4].ToString();
            this.Y_Res_3.Text = resolutions[5].ToString();
            this.X_Res_4.Text = resolutions[6].ToString();
            this.Y_Res_4.Text = resolutions[7].ToString();
            this.Field_Of_View.Text = fov.ToString();
            this.R_Anamorphic.Text = anamorphic.ToString();
        }

        void performDirCheck()
        {
            bloodlinesPath = Directory.GetCurrentDirectory();
            if (!bloodlinesPath.EndsWith(dirSep)) bloodlinesPath = bloodlinesPath + dirSep;

            BIN_DIR = bloodlinesPath + "Bin" + dirSep;
            DLL_DIR = bloodlinesPath + "Vampire" + dirSep + "cl_dlls" + dirSep;
            CFG_DIR = bloodlinesPath + "Vampire" + dirSep + "cfg" + dirSep;

            while (!Directory.Exists(DLL_DIR) && !Directory.Exists(BIN_DIR) && !Directory.Exists(CFG_DIR))
            {
                FolderBrowserDialog folderDialog = new FolderBrowserDialog();
                folderDialog.Description = "Select Vampire Bloodlines Main Folder";
                folderDialog.SelectedPath = Directory.GetCurrentDirectory();

                if (folderDialog.ShowDialog() == DialogResult.OK)
                {
                    bloodlinesPath = folderDialog.SelectedPath;
                    if (!bloodlinesPath.EndsWith(dirSep)) bloodlinesPath = bloodlinesPath + dirSep;

                    BIN_DIR = bloodlinesPath + "Bin" + dirSep;
                    DLL_DIR = bloodlinesPath + "Vampire" + dirSep + "cl_dlls" + dirSep;
                    CFG_DIR = bloodlinesPath + "Vampire" + dirSep + "cfg" + dirSep;

                    if (!Directory.Exists(DLL_DIR))
                    {
                        MessageBox.Show("Could not find " + DLL_DIR);
                    }
                    else
                    {
                        if (!Directory.Exists(BIN_DIR))
                        {
                            MessageBox.Show("Could not find " + BIN_DIR);
                        }
                        else
                        {
                            if (!Directory.Exists(CFG_DIR))
                            {
                                MessageBox.Show("Could not find " + CFG_DIR);
                            }
                        }
                    }
                }
                else
                {
                    Environment.Exit(0);
                }
            }
            
            BIN_FILE = BIN_DIR + "engine.dll";
            DLL_FILE = DLL_DIR + "client.dll";
            CFG_FILE = CFG_DIR + "config.cfg";
        }

        void setupConfig(ref StringBuilder configOutput)
        {
            configOutput.AppendLine("unbindall");
            configOutput.AppendLine("bind \"TAB\" \"+wpn_secondaryatk\"");
            configOutput.AppendLine("bind \"ENTER\" \"+attack\"");
            configOutput.AppendLine("bind \"ESCAPE\" \"cancelselect\"");
            configOutput.AppendLine("bind \"SPACE\" \"+jump\"");
            configOutput.AppendLine("bind \"'\" \"+moveup\"");
            configOutput.AppendLine("bind \",\" \"+moveleft\"");
            configOutput.AppendLine("bind \".\" \"+moveright\"");
            configOutput.AppendLine("bind \"/\" \"+movedown\"");
            configOutput.AppendLine("bind \"0\" \"vhotkey #10\"");
            configOutput.AppendLine("bind \"1\" \"vhotkey #1\"");
            configOutput.AppendLine("bind \"2\" \"vhotkey #2\"");
            configOutput.AppendLine("bind \"3\" \"vhotkey #3\"");
            configOutput.AppendLine("bind \"4\" \"vhotkey #4\"");
            configOutput.AppendLine("bind \"5\" \"vhotkey #5\"");
            configOutput.AppendLine("bind \"6\" \"vhotkey #6\"");
            configOutput.AppendLine("bind \"7\" \"vhotkey #7\"");
            configOutput.AppendLine("bind \"8\" \"vhotkey #8\"");
            configOutput.AppendLine("bind \"9\" \"vhotkey #9\"");
            configOutput.AppendLine("bind \";\" \"+mlook\"");
            configOutput.AppendLine("bind \"[\" \"invnext\"");
            configOutput.AppendLine("bind \"\\\" \"lastinv\"");
            configOutput.AppendLine("bind \"]\" \"invprev\"");
            configOutput.AppendLine("bind \"`\" \"toggleconsole\"");
            configOutput.AppendLine("bind \"a\" \"+moveleft\"");
            configOutput.AppendLine("bind \"b\" \"+moveup\"");
            configOutput.AppendLine("bind \"c\" \"+chareditor\"");
            configOutput.AppendLine("bind \"d\" \"+moveright\"");
            configOutput.AppendLine("bind \"e\" \"+use\"");
            configOutput.AppendLine("bind \"f\" \"+feed\"");
            configOutput.AppendLine("bind \"h\" \"holster\"");
            configOutput.AppendLine("bind \"i\" \"slot6\"");
            configOutput.AppendLine("bind \"k\" \"showhotkeys\"");
            configOutput.AppendLine("bind \"l\" \"+questlog\"");
            configOutput.AppendLine("bind \"p\" \"vphysicshand\"");
            configOutput.AppendLine("bind \"r\" \"+reload\"");
            configOutput.AppendLine("bind \"s\" \"+back\"");
            configOutput.AppendLine("bind \"v\" \"+movedown\"");
            configOutput.AppendLine("bind \"w\" \"+forward\"");
            configOutput.AppendLine("bind \"z\" \"togglecamera\"");
            configOutput.AppendLine("bind \"BACKSPACE\" \"dropitem\"");
            configOutput.AppendLine("bind \"UPARROW\" \"+forward\"");
            configOutput.AppendLine("bind \"DOWNARROW\" \"+back\"");
            configOutput.AppendLine("bind \"LEFTARROW\" \"+left\"");
            configOutput.AppendLine("bind \"RIGHTARROW\" \"+right\"");
            configOutput.AppendLine("bind \"CTRL\" \"+duck\"");
            configOutput.AppendLine("bind \"SHIFT\" \"+speed\"");
            configOutput.AppendLine("bind \"F1\" \"slot2\"");
            configOutput.AppendLine("bind \"F2\" \"slot3\"");
            configOutput.AppendLine("bind \"F3\" \"slot5\"");
            configOutput.AppendLine("bind \"F8\" \"vdiscipline_endall\"");
            configOutput.AppendLine("bind \"F9\" \"save quick\"");
            configOutput.AppendLine("bind \"F10\" \"snapshot\"");
            configOutput.AppendLine("bind \"F12\" \"load quick\"");
            configOutput.AppendLine("bind \"PGDN\" \"dlgscrldn\"");
            configOutput.AppendLine("bind \"PGUP\" \"dlgscrlup\"");
            configOutput.AppendLine("bind \"HOME\" \"dlghist\"");
            configOutput.AppendLine("bind \"MWHEELDOWN\" \"invnext\"");
            configOutput.AppendLine("bind \"MWHEELUP\" \"invprev\"");
            configOutput.AppendLine("bind \"MOUSE1\" \"+attack\"");
            configOutput.AppendLine("bind \"MOUSE2\" \"vdiscipline_last\"");
            configOutput.AppendLine("r_anamorphic \"" + anamorphic + "\"");
            configOutput.AppendLine("bind \"[\" \"invnext\"");
            configOutput.AppendLine("bind \"]\" \"invprev\"");
            configOutput.AppendLine("bind \"p\" \"vphysicshand\"");
            configOutput.AppendLine("camera_prefs \"7\"");
            configOutput.AppendLine("hud_fastswitch \"0\"");
            configOutput.AppendLine("cl_v_image_quality \"1.000000\"");
            configOutput.AppendLine("ai_report_task_timings_on_limit \"1\"");
            configOutput.AppendLine("ai_think_limit_label \"1\"");
            configOutput.AppendLine("sv_noclipaccelerate \"5\"");
            configOutput.AppendLine("sv_noclipspeed \"1000\"");
            configOutput.AppendLine("snd_mixahead \"0.2\"");
            configOutput.AppendLine("volume \"1.0\"");
            configOutput.AppendLine("brightness \"1.250000\"");
            configOutput.AppendLine("con_color \"255 0 0\"");
            configOutput.AppendLine("rate \"2500\"");
            configOutput.AppendLine("cl_timeout \"305\"");
            configOutput.AppendLine("bgmvolume \"1.000000\"");
            configOutput.AppendLine("+mlook");
        }

        void readResolutions()
        {
            try
            {
                binFileContents = File.ReadAllBytes(BIN_FILE);
            }
            catch (Exception e)
            {
                MessageBox.Show("Could not read resolutions from " + BIN_FILE);
                Environment.Exit(0);
            }

            int resFilePtr = 0;
            int timesResStringFound = 0;
            while (resFilePtr < binFileContents.Length)
            {
                if (binFileContents[resFilePtr].Equals((binLookFor[0])))
                {
                    if (resFilePtr + binLookFor.Length <= binFileContents.Length)
                    {
                        bool resStringFound = true;
                        for (int i = 0; i < binLookFor.Length; i++)
                        {
                            if (!(binFileContents[i + resFilePtr].Equals(binLookFor[i])))
                            {
                                resStringFound = false;
                            }
                        }
                        if (resStringFound == true)
                        {
                            binFileResStringStart = resFilePtr;
                            timesResStringFound = timesResStringFound + 1;
                        }
                    }
                }
                resFilePtr++;
            }
            
            if (timesResStringFound == 0)
            {
                MessageBox.Show("The resolution was not found!");
                Environment.Exit(0);
            }
            if (timesResStringFound > 1)
            {
                MessageBox.Show("Too many resolution's were found!");
                Environment.Exit(0);
            }

            for (int i = 0; i < 8; i++)
            {
                resolutions[i] = System.BitConverter.ToInt32(binFileContents, binFileResStringStart + 2 + i * 4 + binLookFor.Length);
            }
        }

        void readFov()
        {
            try
            {
                dllFileContents = File.ReadAllBytes(DLL_FILE);
            }
            catch (Exception e)
            {
                MessageBox.Show("Could not read FOV from " + DLL_FILE);
                Environment.Exit(0);
            }
            
            int fovFilePtr = 0;
            int timesFovFound = 0;
            while (fovFilePtr < dllFileContents.Length)
            {
                if (dllFileContents[fovFilePtr].Equals((dllLookFor[0])))
                {
                    if (fovFilePtr + dllLookFor.Length <= dllFileContents.Length)
                    {
                        bool dllStringFound = true;
                        for (int i = 0; i < dllLookFor.Length; i++)
                        {
                            if (!(dllFileContents[i + fovFilePtr].Equals(dllLookFor[i])))
                            {
                                dllStringFound = false;
                            }
                        }
                        if (dllStringFound == true)
                        {
                            dllFileResStringStart = fovFilePtr;
                            timesFovFound = timesFovFound + 1;
                        }
                    }
                }
                fovFilePtr++;
            }
            
            if (timesFovFound == 0)
            {
                MessageBox.Show("The FOV was not found!");
                Environment.Exit(0);
            }
            if (timesFovFound > 1)
            {
                MessageBox.Show("Too many FOV's were found!");
                Environment.Exit(0);
            }

            int singlets = fov % 10;
            int diglets = (fov - singlets) / 10;

            Char[] fovChars = encoding.GetChars(dllFileContents, dllFileResStringStart + 1 + dllLookFor.Length, 2);
            fov = Int32.Parse(fovChars[0].ToString() + fovChars[1].ToString());
        }

        void readAnamorphic()
        {
            anamorphic = 0;
            if (!File.Exists(CFG_FILE))
            {
                updateDialog("Could not find config file, proceeding without", true);
            }
            else
            {
                String theConfigFile = "";
                try
                {
                    theConfigFile = File.ReadAllText(CFG_FILE, encoding);
                }
                catch (Exception e)
                {
                    MessageBox.Show("Could not read config file " + CFG_FILE);
                    Environment.Exit(0);
                }

                StringReader configFile = new StringReader(theConfigFile);
                bool anamorphicFound = false;
                string line = "";
                while ((line = configFile.ReadLine()) != null)
                {
                    if (line.Contains("r_anamorphic"))
                    {
                        int end = line.LastIndexOf("\"");
                        String subLine = line.Substring(0, end);
                        int start = subLine.LastIndexOf("\"");
                        String value = subLine.Substring(start + 1).Trim();
                        
                        if (Int32.TryParse(value, out anamorphic) == true)
                        anamorphicFound = true;
                    }
                }
                if (anamorphicFound == false)
                {
                    updateDialog("Did not found r_anamorphic in config, proceeding...", true);
                }
            }
        }

        bool testWriteResolution()
        {
            try
            {
                File.WriteAllBytes(BIN_FILE, binFileContents);
            }
            catch (Exception e)
            {
                updateDialog("Test writing failed for " + BIN_FILE);
                return false;
            }
            return true;
        }

        bool writeResolution()
        {
            byte[] displayString = new byte[40];
            for (int i = 0; i < 8; i++)
            {
                byte[] resolution = new byte[4];
                resolution = System.BitConverter.GetBytes(resolutions[i]);
                for (int j = 0; j < 4; j++)
                {
                    displayString[i * 4 + j] = resolution[j];
                }
            }

            for (int i = 0; i < 32; i++)
            {
                binFileContents[binFileResStringStart + i + 2 + binLookFor.Length] = displayString[i];
            }

            try
            {
                File.WriteAllBytes(BIN_FILE, binFileContents);
            }
            catch (Exception e)
            {
                updateDialog("Could not write " + BIN_FILE);
                return false;
            }
            return true;
        }

        bool testWriteFOV()
        {
            try
            {
                File.WriteAllBytes(DLL_FILE, dllFileContents);
            }
            catch (Exception e)
            {
                updateDialog("Test writing failed for " + DLL_FILE);
                return false;
            }
            return true;
        }

        bool writeFOV()
        {
            int singlets = fov % 10;
            int diglets = (fov - singlets) / 10;

            Byte[] singleByte = encoding.GetBytes(singlets.ToString());
            Byte[] digleByte = encoding.GetBytes(diglets.ToString());

            dllFileContents[dllFileResStringStart + 1 + dllLookFor.Length] = digleByte[0];
            dllFileContents[dllFileResStringStart + 2 + dllLookFor.Length] = singleByte[0];

            try
            {
                File.WriteAllBytes(DLL_FILE, dllFileContents);
            }
            catch (Exception e)
            {
                updateDialog("Could not write " + DLL_FILE);
                return false;
            }
            return true;
        }

        bool testWriteAnamorphic()
        {
            if (File.Exists(CFG_FILE))
            {
                configFileExists = true;
            }
            else
            {
                configFileExists = false;
            }

            try
            {
                File.AppendAllText(CFG_FILE, "");
            }
            catch (Exception e)
            {
                updateDialog("Failed to write " + CFG_FILE);
                return false;
            }
            return true;
        }

        bool writeAnamorphic()
        {
            StringBuilder configOutput = new StringBuilder();
            setupConfig(ref configOutput);

            if (configFileExists == true)
            {
                try
                {
                    File.AppendAllText(CFG_FILE, "r_anamorphic \"" + anamorphic + "\"" + Environment.NewLine);
                    configFileExists = false;
                }
                catch (Exception e)
                {
                    updateDialog("Failed to write " + CFG_FILE);
                    return false;
                }
            }
            else
            {
                try
                {
                    File.AppendAllText(CFG_FILE, configOutput.ToString());
                }
                catch (Exception e)
                {
                    updateDialog("Failed to write " + CFG_FILE);
                    return false;
                }
            }
            return true;
        }

        private void Patch_It_Click(object sender, EventArgs e)
        {
            String[] translationTable = { 
                "New X 1", 
                "New Y 1", 
                "New X 2", 
                "New Y 2", 
                "New X 3", 
                "New Y 3", 
                "New X 4", 
                "New Y 4"
            };

            bool writeToDisk = true;

            updateDialog("Checking values", true);

            if (Int32.TryParse(this.X_Res_1.Text, out resolutions[0]) == false)
            {
                updateDialog(translationTable[0] + " contains invalid digits: aborting");
                writeToDisk = false;
            }
            if (Int32.TryParse(this.Y_Res_1.Text, out resolutions[1]) == false)
            {
                updateDialog(translationTable[1] + " contains invalid digits: aborting");
                writeToDisk = false;
            }
            if (Int32.TryParse(this.X_Res_2.Text, out resolutions[2]) == false)
            {
                updateDialog(translationTable[2] + " contains invalid digits: aborting");
                writeToDisk = false;
            }
            if (Int32.TryParse(this.Y_Res_2.Text, out resolutions[3]) == false)
            {
                updateDialog(translationTable[3] + " contains invalid digits: aborting");
                writeToDisk = false;
            }
            if (Int32.TryParse(this.X_Res_3.Text, out resolutions[4]) == false)
            {
                updateDialog(translationTable[4] + " contains invalid digits: aborting");
                writeToDisk = false;
            }
            if (Int32.TryParse(this.Y_Res_3.Text, out resolutions[5]) == false)
            {
                updateDialog(translationTable[5] + " contains invalid digits: aborting");
                writeToDisk = false;
            }
            if (Int32.TryParse(this.X_Res_4.Text, out resolutions[6]) == false)
            {
                updateDialog(translationTable[6] + " contains invalid digits: aborting");
                writeToDisk = false;
            }
            if (Int32.TryParse(this.Y_Res_4.Text, out resolutions[7]) == false)
            {
                updateDialog(translationTable[7] + " contains invalid digits: aborting");
                writeToDisk = false;
            }
            if (Int32.TryParse(this.Field_Of_View.Text, out fov) == false)
            {
                updateDialog("FOV contains invalid digits: aborting");
                writeToDisk = false;
            }
            if (Int32.TryParse(this.R_Anamorphic.Text, out anamorphic) == false)
            {
                updateDialog("R_Anamorphic contains invalid digits: aborting");
                writeToDisk = false;
            }

            if (writeToDisk == true)
            {
                int maxResolutionValue = 10000000;
                int minResolutionValue = 1;
                for (int i = 0; i < 8; i++)
                {
                    if (resolutions[i] > maxResolutionValue)
                    {
                        writeToDisk = false;
                        updateDialog(translationTable[i] + " is larger than " + maxResolutionValue + " : aborting");
                    }
                    if (resolutions[i] < minResolutionValue)
                    {
                        writeToDisk = false;
                        updateDialog(translationTable[i] + " is smaller than " + minResolutionValue + " : aborting");
                    }
                }

                fov = Int32.Parse(this.Field_Of_View.Text);
                int maxFovValue = 99;
                int minFovValue = 1;
                if (fov > maxFovValue)
                {
                    writeToDisk = false;
                    updateDialog("FOV is larger than " + maxFovValue + " : aborting");
                }
                if (fov < minFovValue)
                {
                    writeToDisk = false;
                    updateDialog("FOV is smaller than " + minFovValue + " : aborting");
                }

                anamorphic = Int32.Parse(this.R_Anamorphic.Text);
                int maxAnaValue = 99;
                int minAnaValue = -1;
                if (anamorphic > maxAnaValue)
                {
                    writeToDisk = false;
                    updateDialog("anamorphic is larger than " + maxAnaValue + " : aborting");
                }
                if (anamorphic < minAnaValue)
                {
                    writeToDisk = false;
                    updateDialog("anamorphic is smaller than " + minAnaValue + " : aborting");
                }

                if (writeToDisk == true)
                {
                    updateDialog("Test-writing to files", true);
                    if (
                        doTestWriting == true
                        &&
                            (
                                testWriteResolution() == false
                                || testWriteAnamorphic() == false
                                || testWriteFOV() == false
                            )
                        )
                    {
                        updateDialog("--- Test-writing failed: no files should be changed ---", true);
                    }
                    else
                    {
                        updateDialog("Writing to files", true);
                        if (
                            writeResolution() == false
                            || writeAnamorphic() == false
                            || writeFOV() == false
                        )
                        {
                            updateDialog("--- Update failed, but some files were changed ---", true);
                        }
                        else
                        {
                            updateDialog("+++ Resolution change succesfull! +++", true);
                        }
                    }
                }
            }
        }

        private void About_Click(object sender, EventArgs e)
        {
            updateDialog(@"This tool changes the resolution for Bloodlines. It does so by editing:", false);
            updateDialog(@"Bin\engine.dll, Vampire\cfg\config.cfg and Vampire\cl_dlls", false);
            updateDialog(@" ", false);
            updateDialog(@"It is best if Bloodlines is run once before the tool after re-install.", false);
            updateDialog(@" ", false);
            updateDialog(@"The program may fail because of a lack of writing persmissions.", false);
            updateDialog(@"If it fails for another reason, try editing the files manually.", false);
            updateDialog(@" ", false);
            updateDialog(@"You may edit this software, but you must release the source-code and allow others to edit your source-code as well!", false);
        }

        private void Backup_Click(object sender, EventArgs e)
        {
            bool backupSuccess = true;

            for (int i = 0; i < 3; i++)
            {
                bool backupTried = false;
                int maxBackupTries = 10;
                int backupTries = 0;
                String fileBackup = "";
                String doingBackup = "";
                if (i == 0) doingBackup = BIN_FILE;
                if (i == 1) doingBackup = DLL_FILE;
                if (i == 2) doingBackup = CFG_FILE;

                fileBackup = doingBackup + ".BAK";
                while (backupTries < maxBackupTries && backupTried == false)
                {
                    backupTries++;
                    if (File.Exists(fileBackup))
                    {
                        fileBackup = doingBackup + ".BAK." + DateTime.Now.ToString("M_d_yy_hh_mm_ss");
                    }
                    else
                    {
                        backupTried = true;
                        try
                        {
                            File.Copy(doingBackup, fileBackup);
                            updateDialog("Made backup: " + fileBackup, true);
                        }
                        catch (Exception exp)
                        {
                            updateDialog("--- " + doingBackup + " backup failed ---", true);
                            backupSuccess = false;
                        }
                    }
                }
                if (backupTries == maxBackupTries)
                {
                    updateDialog("--- " + doingBackup + " backup failed ---", true);
                }
            }

            if (backupSuccess == true)
            {
                updateDialog("+++ Backing up files succesfull +++", true);
            }
        }

        private void Quit_Click(object sender, EventArgs e)
        {
            Environment.Exit(0);
        }

        private void Four_To_Three_Screen_Click(object sender, EventArgs e)
        {
            updateDialog("Setting 4:3 values", true);
            resolutions[0] = 640;
            resolutions[1] = 480;
            resolutions[2] = 800;
            resolutions[3] = 600;
            resolutions[4] = 1024;
            resolutions[5] = 768;
            resolutions[6] = 1280;
            resolutions[7] = 1024;
            fov = 75;
            anamorphic = 0;
            updateNewTextBoxes();
        }

        private void Sixteen_To_Nine_Screen_Click(object sender, EventArgs e)
        {
            updateDialog("Setting 16:9 values", true);
            resolutions[0] = 854;
            resolutions[1] = 480;
            resolutions[2] = 1280;
            resolutions[3] = 720;
            resolutions[4] = 1366;
            resolutions[5] = 768;
            resolutions[6] = 1920;
            resolutions[7] = 1080;
            fov = 69;
            anamorphic = 1;
            updateNewTextBoxes();
        }

        private void Sixteen_To_Ten_Screen_Click(object sender, EventArgs e)
        {
            updateDialog("Setting 16:10 values", true);
            resolutions[0] = 1280;
            resolutions[1] = 800;
            resolutions[2] = 1440;
            resolutions[3] = 900;
            resolutions[4] = 1680;
            resolutions[5] = 1050;
            resolutions[6] = 1920;
            resolutions[7] = 1200;
            fov = 69;
            anamorphic = 2;
            updateNewTextBoxes();
        }

        public ResPatcher()
        {
            InitializeComponent();

            updateDialog("Performing directory checks", true);
            performDirCheck();

            updateDialog("Reading resolutions", true);
            readResolutions();
            updateDialog("Reading FOV", true);
            readFov();
            updateDialog("Reading r_anamorphic", true);
            readAnamorphic();

            updateOldTextBoxes();
            updateNewTextBoxes();
        }
    }
}